package timers;

import java.util.concurrent.Future;

import javax.ejb.AsyncResult;
import javax.ejb.EJB;
import javax.ejb.Lock;
import javax.ejb.LockType;
import javax.ejb.Schedule;
import javax.ejb.Singleton;

import asynch.AsynchEjb;

@Singleton
public class TimedEJB {

	static int timedEventsCalls = 0;

	@EJB
	AsynchEjb asynch;

	private Future<String> asyncResult = new AsyncResult<String>("empty");

	/**
	 * Default constructor.
	 */
	public TimedEJB() {
	}

	@Schedule(second = "0/30", minute = "*", hour = "*", persistent = false)
	@Lock(LockType.READ)
	public void timedEvent() {

		int currentActivation = ++timedEventsCalls;
		System.out.println("&&&" + this + " " + currentActivation
				+ " Timed Event start");

		System.out.println("&&&" + this + " " + currentActivation + " "
				+ asyncResult.isDone());

		if (asyncResult.isDone()) {
			System.out.println("&&&" + this + " " + currentActivation
					+ " Executing");
			asyncResult = asynch.asynchFoo();

		} else {
			System.out.println("&&&" + this + " " + currentActivation
					+ " Skipped Execution");
		}

		System.out.println("&&&" + this + " " + currentActivation
				+ " Timed Event end");
	}
}
